---
title: HTMLImageElement.loading
slug: Web/API/HTMLImageElement/loading
tags:
  - API
  - Content
  - Eager
  - Graphics
  - HTML DOM
  - HTMLImageElement
  - Images
  - Layout
  - Lazy
  - Lazy-loading
  - Loading
  - Performance
  - Pictures
  - Property
  - Reference
  - load
  - rendering
---
<p>{{APIRef("HTML DOM")}}</p>

<p><span class="seoSummary">The {{domxref("HTMLImageElement")}} property <code><strong>loading</strong></code> is a string whose value provides a hint to the {{Glossary("user agent")}} on how to handle the loading of the image which is currently outside the window's {{Glossary("visual viewport")}}.</span> This helps to optimize the loading of the document's contents by postponing loading the image until it's expected to be needed, rather than immediately during the initial page load.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">let <em>imageLoadScheduling</em> = <em>htmlImageElement</em>.loading;
<em>htmlImageElement</em>.loading = <em>eagerOrLazy</em>;
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} providing a hint to the user agent as to how to best schedule the loading of the image to optimize page performance. The possible values are:</p>

<dl>
 <dt><code>eager</code></dt>
 <dd>The default behavior, <code>eager</code> tells the browser to load the image as soon as the <code>&lt;img&gt;</code> element is processed.</dd>
 <dt><code>lazy</code></dt>
 <dd>Tells the user agent to hold off on loading the image until the browser estimates that it will be needed imminently. For instance, if the user is scrolling through the document, a value of <code>lazy</code> will cause the image to only be loaded shortly before it will appear in the window's {{Glossary("visual viewport")}}.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<h3 id="Timing_of_the_load_event">Timing of the load event</h3>

<p>The {{domxref("Window.load_event", "load")}} event is fired when the document has been fully processed. When images are loaded eagerly (which is the default), every image in the document must be fetched before the <code>load</code> event can fire.</p>

<p>By specifying the value <code>lazy</code> for <code>loading</code>, you prevent the image from delaying the <code>load</code> attribute by the amount of time it takes to request, fetch, and process the image.</p>

<p>Images whose <code>loading</code> attribute is set to <code>lazy</code> but are located within the visual viewport immediately upon initial page load are loaded as soon as the layout is known, but their loads do not delay the firing of the <code>load</code> event. In other words, these images aren't loaded immediately when processing the <code>&lt;img&gt;</code> element, but are still loaded as part of the initial page load. They justt don't affect the timing of the <code>load</code> event.</p>

<p>That means that when <code>load</code> fires, it's possible that any lazy-loaded images located in the visual viewport may not yet be visible.</p>

<h3 id="Preventing_element_shift_during_image_lazy_loads">Preventing element shift during image lazy loads</h3>

<p>When an image whose loading has been delayed by the <code>loading</code> attribute being set to <code>lazy</code> is finally loaded, the browser will determine the final size of the {{HTMLElement("img")}} element based on the style and intrinsic size of the image, then reflow the document as needed to update the positions of elements based on any size change made to the element to fit the image.</p>

<p>To prevent this reflow from occurring, you should explicitly specify the size of the image's presentation using the image element's {{htmlattrxref("width", "img")}} and {{htmlattrxref("height", "img")}} attributes. By establishing the intrinsic aspect ratio in this manner, you prevent elements from shifting around while the document loads, which can be disconcerting or offputting at best and can cause users to click the wrong thing at worst, depending on the exact timing of the deferred loads and reflows.</p>

<h2 id="Example">Example</h2>

<p>The <code>addImageToList()</code> function shown below adds a photo thumbnail to a list of items, using lazy-loading to avoid loading the image from the network until it's actually needed.</p>

<pre class="brush: js notranslate">function addImageToList(url) {
  const list = document.querySelector("div.photo-list");

  let newItem = document.createElement("div");
  newItem.className = "photo-item";

  let newImg = document.createElement("img");
  newImg.loading = "lazy";
  newImg.width = 320;
  newImg.height = 240;
  newImg.src = url;

  newItem.appendChild(newImg);
  list.appendChild(newItem);
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', "#attr-img-loading", "HTMLImageElement.loading")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLImageElement.loading")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{HTMLElement("img")}} element</li>
 <li><a href="/en-US/docs/Learn/Performance">Web performance</a> in the MDN Learning Area</li>
 <li><a href="/en-US/docs/Web/Performance/Lazy_loading">Lazy loading</a> in the MDN web performance guide</li>
 <li>{{SectionOnPage("/en-US/docs/Learn/HTML/Howto/Author_fast-loading_HTML_pages", "Use lazy loading for images")}}</li>
</ul>
